libosmocore 1.13.1.1-afb4 Osmocom core library

Data Fields
msgb Struct Reference
Message buffers

Osmocom message buffer. More...

`#include <msgb.h>`

## Data Fields
struct llist_head | list
| linked list header More...
union {
void * dst
| reference of origin/destination More...
struct gsm_bts_trx * trx
}; |
struct gsm_lchan * | lchan
| logical channel More...
unsigned char * | l1h
| pointer to Layer1 header (if any) More...
unsigned char * | l2h
| pointer to A-bis layer 2 header: OML, RSL(RLL), NS More...
unsigned char * | l3h
| pointer to Layer 3 header. More...
unsigned char * | l4h
| pointer to layer 4 header More...
unsigned long | cb [5]
| control buffer More...
uint16_t | data_len
| length of underlying data array More...
uint16_t | len
| length of bytes used in msgb More...
unsigned char * | head
| start of underlying memory buffer More...
unsigned char * | tail
| end of message in buffer More...
unsigned char * | data
| start of message in buffer More...
unsigned char | _data [0]
| optional immediate data array More...

## Detailed Description

Osmocom message buffer.

## Field Documentation

## ◆

union { ... } msgb::@17

## ◆ _data

unsigned char msgb::_data[0]

optional immediate data array

Referenced by msgb_copy_resize_c(), msgb_push(), and msgb_put().

## ◆ cb

unsigned long msgb::cb[5]

control buffer

## ◆ data

unsigned char* msgb::data

start of message in buffer

Referenced by msgb_copy_resize_c(), msgb_headroom(), msgb_pull(), msgb_push(), and osmo_sercomm_drv_pull().

## ◆ data_len

uint16_t msgb::data_len

length of underlying data array

Referenced by msgb_headlen(), msgb_push(), msgb_put(), and msgb_tailroom().

## ◆ dst

void* msgb::dst

reference of origin/destination

## ◆ head

unsigned char* msgb::head

start of underlying memory buffer

Referenced by msgb_copy_resize_c(), msgb_headroom(), msgb_push(), msgb_put(), and msgb_tailroom().

## ◆ l1h

unsigned char* msgb::l1h

pointer to Layer1 header (if any)

Referenced by msgb_copy_resize_c(), and msgb_l1len().

## ◆ l2h

unsigned char* msgb::l2h

pointer to A-bis layer 2 header: OML, RSL(RLL), NS

Referenced by msgb_copy_resize_c(), and msgb_l2len().

## ◆ l3h

unsigned char* msgb::l3h

pointer to Layer 3 header.

For OML: FOM; RSL: 04.08; GPRS: BSSGP

Referenced by msgb_copy_resize_c(), and msgb_l3len().

## ◆ l4h

unsigned char* msgb::l4h

pointer to layer 4 header

Referenced by msgb_copy_resize_c(), and msgb_l4len().

## ◆ lchan

struct gsm_lchan* msgb::lchan

logical channel

## ◆ len

uint16_t msgb::len

length of bytes used in msgb

Referenced by msgb_copy_resize_c(), msgb_get(), msgb_headlen(), msgb_pull(), msgb_push(), msgb_push_tl(), and msgb_put().

## ◆ list

struct llist_head msgb::list

linked list header

## ◆ tail

unsigned char* msgb::tail

end of message in buffer

Referenced by iofd_poll_ofd_cb_recvmsg_sendmsg(), msgb_copy_resize_c(), msgb_get(), msgb_l1len(), msgb_l2len(), msgb_l3len(), msgb_l4len(), msgb_printf(), msgb_put(), msgb_tailroom(), and osmo_sercomm_drv_pull().

## ◆ trx

struct gsm_bts_trx* msgb::trx

The documentation for this struct was generated from the following file:

- include/osmocom/core/msgb.h